#!/usr/bin/env python
"""
setup.py - script for building application

Usage:
    % python setup.py py2app
"""
from distutils.core import setup
import platform

if platform.system() == 'Windows':
    import py2exe
    import os
    import zmq, numpy

    # libzmq.dll is in same directory as zmq's __init__.py
    os.environ["PATH"] = \
    os.environ["PATH"] + \
    os.path.pathsep + os.path.split(zmq.__file__)[0]

    setup(
        console = ['run_all.py'], requires=['netCDF4'],
        options={
            "py2exe": {
                "includes":
                ["zmq.utils", "zmq.utils.jsonapi",
                "zmq.utils.strtypes"] } }
    )
elif platform.system() == 'Darwin':
    import py2app
    setup(
        app = ['preprocess_IAM.py'], requires=['netCDF4']
    )
else:
    print 'Unknown platform! Cannot create executable.'